Index: mist_5200_old_sd_interface/pll_ntsc.ppf
===================================================================
--- mist_5200_old_sd_interface/pll_ntsc.ppf	(nonexistent)
+++ mist_5200_old_sd_interface/pll_ntsc.ppf	(revision 232)
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+<!DOCTYPE pinplan>
+<pinplan intended_family="Cyclone III" variation_name="pll_ntsc" megafunction_name="ALTPLL" specifies="all_ports">
+<global>
+<pin name="inclk0" direction="input" scope="external" source="clock"  />
+<pin name="c0" direction="output" scope="external" source="clock"  />
+<pin name="c1" direction="output" scope="external" source="clock"  />
+<pin name="c2" direction="output" scope="external" source="clock"  />
+<pin name="c3" direction="output" scope="external" source="clock"  />
+<pin name="locked" direction="output" scope="external"  />
+
+</global>
+</pinplan>
Index: mist_5200_old_sd_interface/simulate_data_io.sh
===================================================================
--- mist_5200_old_sd_interface/simulate_data_io.sh	(nonexistent)
+++ mist_5200_old_sd_interface/simulate_data_io.sh	(revision 232)
@@ -0,0 +1,65 @@
+#!/bin/bash
+
+echo "---------------------------------------------------------"
+echo "Use 'simulate -run' to skip compilation stage."
+echo "Use 'simulate -view' to show previous simulation results."
+echo "---------------------------------------------------------"
+
+name=data_io
+
+
+
+. /home/markw/fpga/xilinx/14.7/ISE_DS/settings64.sh
+
+mkdir -p sim
+pushd sim
+
+# if we have a WDB file, we can view it if requested (otherwise we remove it)
+if [ ! -e $name.wdb -o "$1" != "-view" ]; then
+
+    rm -f $name.wdb
+
+    # if we have a EXE, we can run it if requested (otherwise we remove it)
+    if [ ! -e $name.exe -o "$1" != "-run" ]; then
+
+        rm -f $name.exe
+
+        # copy testbench files
+        cp -p ../tb_data/* .
+
+        # copy source files
+	cp ../data_io.vhdl .
+	cp ../../common/components/spi_master.vhd .
+	cp ../../common/components/generic_ram_infer.vhdl .
+
+        # set up project definition file
+	ls *.v | perl -e 'while (<>){s/(.*)/verilog work $1/;print $_;}' | cat > $name.prj
+	ls *.vhd* | perl -e 'while (<>){s/(.*)/vhdl work $1/;print $_;}' | cat >> $name.prj
+	echo NumericStdNoWarnings = 1 >> xilinxsim.ini
+
+        # verbose & no multthreading - fallback in case of problems
+        # fuse -v 1 -mt off -incremental -prj %name%.prj -o %name%.exe -t %name%
+
+        fuse -timeprecision_vhdl 1fs -incremental -prj $name.prj -o $name.exe -t ${name}_tb || exit 1
+        # fuse --mt off -prj %name%.prj -o %name%.exe -t %name%_tb
+
+        # Check for the EXE again, independent of the errorlevel of fuse...
+        [ -e $name.exe ] || echo "No simulation executable created"
+
+
+    fi
+
+    # Open the iSIM GUI and run the simulation
+    ./$name.exe -gui -f ../$name.cmd -wdb $name.wdb -log $name.log -view ../$name.wcfg || exit 1
+    #strace ./$name.exe -gui -f ../$name.cmd -wdb $name.wdb -log $name.log -view ../$name.wcfg >& out
+    #./$name.exe -h -log $name.log 
+
+
+else
+
+    # Only start the viewer on an existing wave configuration (from an old simulation)
+    isimgui -view ../$name.wcfg || exit 1
+
+fi
+
+popd

Index: mist_5200/atari800core_mist.vhd
===================================================================
--- mist_5200/atari800core_mist.vhd	(revision 231)
+++ mist_5200/atari800core_mist.vhd	(revision 232)
@@ -116,6 +116,34 @@
 	  );
 	end component;
 
+	component sd_card
+	PORT (
+		-- link to user_io for io controller
+		io_lba : out std_logic_vector(31 downto 0);
+		io_rd : out std_logic;
+		io_wr : out std_logic;
+		io_ack : in std_logic;
+		io_conf : out std_logic;
+		io_sdhc : out std_logic;
+		
+		-- data coming in from io controller
+		io_din : in std_logic_vector(7 downto 0);
+		io_din_strobe : in std_logic;
+		
+		-- data going out to io controller
+		io_dout : out std_logic_vector(7 downto 0);
+		io_dout_strobe : in std_logic;
+		
+		-- configuration input
+		allow_sdhc : in std_logic;
+	
+		sd_cs : in std_logic;
+		sd_sck : in std_logic;
+		sd_sdi : in std_logic;
+		sd_sdo : out std_logic
+	); 
+	end component;
+
   signal AUDIO_L_PCM : std_logic_vector(15 downto 0);
   signal AUDIO_R_PCM : std_logic_vector(15 downto 0);
 
@@ -132,12 +160,6 @@
 
   SIGNAL PS2_CLK : std_logic;
   SIGNAL PS2_DAT : std_logic;
-  SIGNAL	CONSOL_OPTION_RAW :  STD_LOGIC;
-  SIGNAL	CONSOL_OPTION :  STD_LOGIC;
-  SIGNAL	CONSOL_SELECT_RAW :  STD_LOGIC;
-  SIGNAL	CONSOL_SELECT :  STD_LOGIC;
-  SIGNAL	CONSOL_START_RAW :  STD_LOGIC;
-  SIGNAL	CONSOL_START :  STD_LOGIC;
   SIGNAL FKEYS : std_logic_vector(11 downto 0);
 
   signal capslock_pressed : std_logic;
@@ -144,22 +166,6 @@
   signal capsheld_next : std_logic;
   signal capsheld_reg : std_logic;
   
-  signal mist_sector_ready : std_logic;
-  signal mist_sector_ready_sync : std_logic;
-  signal mist_sector_request : std_logic;
-  signal mist_sector_request_sync : std_logic;
-  signal mist_sector_write : std_logic;
-  signal mist_sector_write_sync : std_logic;
-  signal mist_sector : std_logic_vector(25 downto 0);
-  signal mist_sector_sync : std_logic_vector(25 downto 0);
-  
-  		
-  signal mist_addr : std_logic_vector(8 downto 0);
-  signal mist_do : std_logic_vector(7 downto 0);
-  signal mist_di : std_logic_vector(7 downto 0);
-  signal mist_wren : std_logic;
-  
-  signal spi_miso_data : std_logic;
   signal spi_miso_io : std_logic;
 
   signal mist_buttons : std_logic_vector(1 downto 0);
@@ -229,12 +235,23 @@
 	signal pause_atari : std_logic;
 	SIGNAL speed_6502 : std_logic_vector(5 downto 0);
 
-	-- mist sector
-	signal ZPU_ROM_DATA_MUX :  std_logic_vector(31 downto 0);
-	signal ZPU_SECTOR_DATA :  std_logic_vector(31 downto 0);
-	signal ZPU_ROM_DO :  std_logic_vector(31 downto 0);
-	signal ZPU_ROM_WREN :  std_logic;
+	-- connection to sd card emulation
+	signal sd_lba : std_logic_vector(31 downto 0);
+	signal sd_rd : std_logic;
+	signal sd_wr : std_logic;
+	signal sd_ack : std_logic;
+	signal sd_conf : std_logic;
+	signal sd_sdhc : std_logic;
+	signal sd_dout : std_logic_vector(7 downto 0);
+	signal sd_dout_strobe : std_logic;
+	signal sd_din : std_logic_vector(7 downto 0);
+	signal sd_din_strobe : std_logic;
 
+	signal mist_sd_sdo : std_logic;
+	signal mist_sd_sck : std_logic;
+	signal mist_sd_sdi : std_logic;
+	signal mist_sd_cs : std_logic;
+
 	-- ps2
 	signal SLOW_PS2_CLK : std_logic; -- around 16KHz
 
@@ -249,138 +266,8 @@
 composite_on_hsync <= '1' when composite_sync=1 else '0';
 
 -- mist spi io
-mist_spi_interface : entity work.data_io 
-	PORT map
-	(
-		CLK =>spi_sck,
-		RESET_n =>reset_n,
-		
-		-- SPI connection - up to upstream to make miso 'Z' on ss_io going high
-		SPI_CLK =>spi_sck,
-		SPI_SS_IO => spi_ss2,
-		SPI_MISO => spi_miso_data,
-		SPI_MOSI => spi_di,
-		
-		-- Sector access request
-		read_request => mist_sector_request_sync,
-		write_request => mist_sector_write_sync,
-		--request => mist_sector_request_sync,
-		sector => mist_sector_sync(25 downto 0),
-		ready => mist_sector_ready,
-		
-		-- DMA to RAM
-		ADDR => mist_addr,
-		DATA_OUT => mist_do,
-		DATA_IN => mist_di,
-		WR_EN => mist_wren
-	 );
- 
-	-- TODO, review if these are all needed when ZPU connected again...
-	select_sync : entity work.synchronizer
-	PORT MAP ( CLK => clk, raw => mist_sector_ready, sync=>mist_sector_ready_sync);
+	spi_do <= spi_miso_io when CONF_DATA0 ='0' else 'Z';
 
-	select_sync2 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector_request, sync=>mist_sector_request_sync);
-
-	select_sync3 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector_write, sync=>mist_sector_write_sync);
-
-	sector_sync0 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(0), sync=>mist_sector_sync(0));
-
-	sector_sync1 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(1), sync=>mist_sector_sync(1));
-
-	sector_sync2 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(2), sync=>mist_sector_sync(2));
-
-	sector_sync3 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(3), sync=>mist_sector_sync(3));
-
-	sector_sync4 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(4), sync=>mist_sector_sync(4));
-
-	sector_sync5 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(5), sync=>mist_sector_sync(5));
-
-	sector_sync6 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(6), sync=>mist_sector_sync(6));
-
-	sector_sync7 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(7), sync=>mist_sector_sync(7));
-
-	sector_sync8 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(8), sync=>mist_sector_sync(8));
-
-	sector_sync9 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(9), sync=>mist_sector_sync(9));
-
-	sector_sync10 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(10), sync=>mist_sector_sync(10));
-
-	sector_sync11 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(11), sync=>mist_sector_sync(11));
-
-	sector_sync12 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(12), sync=>mist_sector_sync(12));
-
-	sector_sync13 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(13), sync=>mist_sector_sync(13));
-
-	sector_sync14 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(14), sync=>mist_sector_sync(14));
-
-	sector_sync15 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(15), sync=>mist_sector_sync(15));
-
-	sector_sync16 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(16), sync=>mist_sector_sync(16));
-
-	sector_sync17 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(17), sync=>mist_sector_sync(17));
-
-	sector_sync18 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(18), sync=>mist_sector_sync(18));
-
-	sector_sync19 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(19), sync=>mist_sector_sync(19));
-
-	sector_sync20 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(20), sync=>mist_sector_sync(20));
-
-	sector_sync21 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(21), sync=>mist_sector_sync(21));
-
-	sector_sync22 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(22), sync=>mist_sector_sync(22));
-
-	sector_sync23 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(23), sync=>mist_sector_sync(23));
-
-	sector_sync24 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(24), sync=>mist_sector_sync(24));
-
-	sector_sync25 : entity work.synchronizer
-	PORT MAP ( CLK => spi_sck, raw => mist_sector(25), sync=>mist_sector_sync(25));
-	
-	
-	spi_do <= spi_miso_io when CONF_DATA0 ='0' else spi_miso_data when spi_SS2='0' else 'Z';
-
-mist_sector_buffer1 : entity work.mist_sector_buffer
-	PORT map
-	(
-		address_a		=> mist_addr,
-		address_b		=> zpu_addr_rom(8 downto 2),
-		clock_a		=> spi_sck,
-		clock_b		=> clk,
-		data_a		=> mist_do,
-		data_b		=> dma_write_data(7 downto 0)&dma_write_data(15 downto 8)&dma_write_data(23 downto 16)&dma_write_data(31 downto 24),
-		wren_a		=> mist_wren,
-		wren_b		=> zpu_rom_wren, 
-		q_a		=> mist_di,
-		q_b		=> zpu_sector_data
-	);
-	
 my_user_io : user_io
 	PORT map(
 	   SPI_CLK => SPI_SCK,
@@ -395,22 +282,50 @@
 		JOYSTICK_ANALOG_1(7 downto 0) => joy1y,
 		BUTTONS => mist_buttons,
 		SWITCHES => mist_switches,
+		STATUS => open,
+
 		PS2_CLK => SLOW_PS2_CLK,
 		PS2_KBD_CLK => ps2_clk,
 		PS2_KBD_DATA => ps2_dat,
-		STATUS => open,
+	
 		SERIAL_DATA => (others=>'0'),
 		SERIAL_STROBE => '0',
 
-		sd_lba => (others=>'0'),
-		sd_rd => '0',
-		sd_wr => '0',
-		sd_conf => '0',
-		sd_sdhc => '0',
-		sd_din => (others=>'0')
-
+		sd_lba => sd_lba,
+		sd_rd => sd_rd,
+		sd_wr => sd_wr,
+		sd_ack => sd_ack,
+		sd_conf => sd_conf,
+		sd_sdhc => sd_sdhc,
+		sd_dout => sd_dout,
+		sd_dout_strobe => sd_dout_strobe,
+		sd_din => sd_din,
+		sd_din_strobe => sd_din_strobe
 	  );
 
+my_sd_card : sd_card
+	PORT map (
+		io_lba => sd_lba,
+		io_rd => sd_rd,
+		io_wr => sd_wr,
+		io_ack => sd_ack,
+		io_conf => sd_conf,
+		io_sdhc => sd_sdhc,
+		
+		io_din => sd_dout,
+		io_din_strobe => sd_dout_strobe,
+		
+		io_dout => sd_din,
+		io_dout_strobe => sd_din_strobe,
+		
+		allow_sdhc => '1',
+	
+		sd_cs => mist_sd_cs,
+		sd_sck => mist_sd_sck,
+		sd_sdi => mist_sd_sdi,
+		sd_sdo => mist_sd_sdo
+	); 
+	  
 	 joy1_n <= not(joy1(5)&joy1(3 downto 0));
 	 joy2_n <= not(joy2(5)&joy2(3 downto 0));
 
@@ -431,28 +346,9 @@
 
 		FKEYS => FKEYS
 	);
---keyboard_map1 : entity work.ps2_to_atari800
---	PORT MAP
---	( 
---		CLK => clk,
---		RESET_N => reset_n,
---		PS2_CLK => ps2_clk,
---		PS2_DAT => ps2_dat,
---		
---		KEYBOARD_SCAN => KEYBOARD_SCAN,
---		KEYBOARD_RESPONSE => KEYBOARD_RESPONSE,
---
---		CONSOL_START => CONSOL_START_RAW,
---		CONSOL_SELECT => CONSOL_SELECT_RAW,
---		CONSOL_OPTION => CONSOL_OPTION_RAW,
---		
---		FKEYS => FKEYS
---	);
+-- stick 0: consol(1 downto 0)="00"
 
-CONSOL_START <= CONSOL_START_RAW or (mist_buttons(1) and not(joy1_n(4)));
-joy_still <= joy1_n(3) and joy1_n(2) and joy1_n(1) and joy1_n(0);
-CONSOL_SELECT <= CONSOL_SELECT_RAW or (mist_buttons(1) and joy1_n(4) and not(joy_still));
-CONSOL_OPTION <= CONSOL_OPTION_RAW or (mist_buttons(1) and joy1_n(4) and joy_still);
+joy_still <= joy1_n(3) and joy1_n(2) and joy1_n(1) and joy1_n(0); -- TODO, need something better here I think! e.g. keypad? 5200 not centreing
 	 
 dac_left : hq_dac
 port map
@@ -724,7 +620,7 @@
 	GENERIC MAP
 	(
 		platform => 1,
-		spi_clock_div => 1 -- 28MHz/2. Max for SD cards is 25MHz...
+		spi_clock_div => 16 -- 28MHz/2. Max for SD cards is 25MHz...
 	)
 	PORT MAP
 	(
@@ -746,16 +642,15 @@
 		-- rom bus master
 		-- data on next cycle after addr
 		ZPU_ADDR_ROM => zpu_addr_rom,
-		ZPU_ROM_DATA => zpu_rom_data_mux,
+		ZPU_ROM_DATA => zpu_rom_data,
 	
-		ZPU_ROM_WREN => zpu_rom_wren, -- special for mist...
+		ZPU_ROM_WREN => open,
 
 		-- spi master
-		-- not used for mist...
-		ZPU_SD_DAT0 => '0',
-		ZPU_SD_CLK => open,
-		ZPU_SD_CMD => open,
-		ZPU_SD_DAT3 => open,
+		ZPU_SD_DAT0 => mist_sd_sdo,
+		ZPU_SD_CLK => mist_sd_sck,
+		ZPU_SD_CMD => mist_sd_sdi,
+		ZPU_SD_DAT3 => mist_sd_cs,
 
 		-- SIO
 		-- Ditto for speaking to Atari, we have a built in Pokey
@@ -769,7 +664,7 @@
 		ZPU_IN1 => X"00000"&(FKEYS(11) or (mist_buttons(0) and not(joy1_n(4))))&(FKEYS(10) or (mist_buttons(0) and joy1_n(4) and joy_still))&(FKEYS(9) or (mist_buttons(0) and joy1_n(4) and not(joy_still)))&FKEYS(8 downto 0),
 		ZPU_IN2 => X"00000000",
 		ZPU_IN3 => X"00000000",
-		ZPU_IN4 => X"000000"&"0000000"&mist_sector_ready_sync,
+		ZPU_IN4 => X"00000000",
 
 		-- ouputs - e.g. Atari system control, halt, throttle, rom select
 		ZPU_OUT1 => zpu_out1,
@@ -778,10 +673,6 @@
 		ZPU_OUT4 => zpu_out4
 	);
 
-	mist_sector <= zpu_out4(25 downto 0);
-	mist_sector_request <= zpu_out4(26);
-	mist_sector_write <= zpu_out4(27);
-
 	pause_atari <= zpu_out1(0);
 	reset_atari <= zpu_out1(1);
 	speed_6502 <= zpu_out1(7 downto 2);
@@ -795,14 +686,6 @@
 	        q => zpu_rom_data
 	);
 
-process(zpu_addr_rom, zpu_rom_data, zpu_sector_data)
-begin
-	zpu_rom_data_mux <= zpu_rom_data;
-	if (zpu_addr_rom(15 downto 14) = "01") then
-		zpu_rom_data_mux <= zpu_sector_data(7 downto 0)&zpu_sector_data(15 downto 8)&zpu_sector_data(23 downto 16)&zpu_sector_data(31 downto 24);
-	end if;
-end process;
-
 enable_179_clock_div_zpu_pokey : entity work.enable_divider
 	generic map (COUNT=>32) -- cycle_length
 	port map(clk=>clk,reset_n=>reset_n,enable_in=>'1',enable_out=>zpu_pokey_enable);
Index: mist_5200/sd_card.v
===================================================================
--- mist_5200/sd_card.v	(nonexistent)
+++ mist_5200/sd_card.v	(revision 232)
@@ -0,0 +1,485 @@
+// 
+// sd_card.v
+//
+// This file implelents a sd card for the MIST board since on the board
+// the SD card is connected to the ARM IO controller and the FPGA has no
+// direct connection to the SD card. This file provides a SD card like
+// interface to the IO controller easing porting of cores that expect
+// a direct interface to the SD card.
+//
+// Copyright (c) 2014 Till Harbaum <till@harbaum.org>
+//
+// This source file is free software: you can redistribute it and/or modify
+// it under the terms of the Lesser GNU General Public License as published
+// by the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// This source file is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program.  If not, see <http://www.gnu.org/licenses/>.
+//
+// http://elm-chan.org/docs/mmc/mmc_e.html
+
+// TODO:
+// - CMD9: SEND_CSD (requires device capacity)
+// - CMD10: SEND_CID
+
+module sd_card (
+	// link to user_io for io controller
+	output [31:0] io_lba,
+	output reg    io_rd,
+	output reg    io_wr,
+	input			  io_ack,
+	output		  io_conf,
+	output		  io_sdhc,
+	
+	// data coming in from io controller
+	input	[7:0]	  io_din,
+	input 		  io_din_strobe,
+
+	// data going out to io controller
+	output [7:0]  io_dout,
+	input 		  io_dout_strobe,
+
+	// configuration input
+	input         allow_sdhc,
+	
+   input         sd_cs,
+   input         sd_sck,
+   input         sd_sdi,
+   output reg    sd_sdo
+); 
+
+// set io_rd once read_state machine starts waiting (rising edge of req_io_rd)
+// and clear it once io controller uploads something (io_ack==1) 
+wire req_io_rd = (read_state == RD_STATE_WAIT_IO);
+always @(posedge req_io_rd or posedge io_ack) begin
+	if(io_ack) io_rd <= 1'b0;
+	else 		  io_rd <= 1'b1;
+end
+
+wire req_io_wr = (write_state == WR_STATE_BUSY);
+always @(posedge req_io_wr or posedge io_ack) begin
+	if(io_ack) io_wr <= 1'b0;
+	else 		  io_wr <= 1'b1;
+end
+
+wire [31:0] OCR = { 1'b0, io_sdhc, 30'h0 };  // bit30 = 1 -> high capaciry card (sdhc)
+wire [7:0] READ_DATA_TOKEN = 8'hfe;
+
+localparam NCR=4;
+
+// 0=idle, 1=wait for io ctrl, 2=wait for byte start, 3=send token, 4=send data, 5/6=send crc[0..1]
+localparam RD_STATE_IDLE       = 3'd0;
+localparam RD_STATE_WAIT_IO    = 3'd1;
+localparam RD_STATE_WAIT_START = 3'd2;
+localparam RD_STATE_SEND_TOKEN = 3'd3;
+localparam RD_STATE_SEND_DATA  = 3'd4;
+localparam RD_STATE_SEND_CRC0  = 3'd5;
+localparam RD_STATE_SEND_CRC1  = 3'd6;
+reg [2:0] read_state = RD_STATE_IDLE;  
+
+// 0=idle
+localparam WR_STATE_IDLE       = 3'd0;
+localparam WR_STATE_EXP_DTOKEN = 3'd1;
+localparam WR_STATE_RECV_DATA  = 3'd2;
+localparam WR_STATE_RECV_CRC0  = 3'd3;
+localparam WR_STATE_RECV_CRC1  = 3'd4;
+localparam WR_STATE_SEND_DRESP = 3'd5;
+localparam WR_STATE_BUSY       = 3'd6;
+reg [2:0] write_state = WR_STATE_IDLE;  
+
+reg [6:0] sbuf; 
+reg cmd55;
+reg new_cmd_rcvd;
+reg [7:0] cmd;
+reg [2:0] bit_cnt;           // counts bits 0-7 0-7 ...
+reg [3:0] byte_cnt= 4'd15;   // counts bytes
+
+reg [31:0] lba;
+assign io_lba = io_sdhc?lba:{9'd0, lba[31:9]};
+
+// the command crc is actually never evaluated
+reg [7:0] crc;
+
+reg [7:0] reply;
+reg [7:0] reply0, reply1, reply2, reply3;
+reg [3:0] reply_len;
+
+// signals to address buffer on SD card write (data coming from SD spi)
+reg write_strobe;
+reg [7:0] write_data;
+
+// falling edge of io_ack signals that a sector to be read has been written into
+// the sector bufffer by the io controller. This signal is kept set as long
+// as the read state machine is in the "wait for io controller" state (state 1)
+wire rd_wait_io = (read_state == RD_STATE_WAIT_IO);
+reg rd_io_ack = 1'b0 /* synthesis noprune */;
+always @(negedge io_ack or negedge rd_wait_io) begin
+	if(!rd_wait_io) rd_io_ack <= 1'b0;
+	else            rd_io_ack <= 1'b1;
+end
+
+wire wr_wait_io = (write_state == WR_STATE_BUSY);
+reg wr_io_ack = 1'b0 /* synthesis noprune */;
+always @(negedge io_ack or negedge wr_wait_io) begin
+	if(!wr_wait_io) wr_io_ack <= 1'b0;
+	else            wr_io_ack <= 1'b1;
+end
+
+// ------------------------- SECTOR BUFFER -----------------------
+
+// access to the sector buffer is multiplexed. When reading sectors 
+// the io controller writes into the buffer and the sd card implementation
+// reads. And vice versa when writing sectors
+wire reading = (read_state != RD_STATE_IDLE);
+wire writing = (write_state != WR_STATE_IDLE);
+
+// the buffer itself. Can hold one sector
+reg [8:0] buffer_wptr;
+reg [8:0] buffer_rptr;
+reg [7:0] buffer [511:0];
+reg [7:0] buffer_byte;
+
+// ---------------- buffer read engine -----------------------
+reg core_buffer_read_strobe;
+wire buffer_read_latch = reading?sd_sck:io_dout_strobe;
+wire buffer_read_strobe = reading?core_buffer_read_strobe:!io_dout_strobe;
+assign io_dout = buffer_byte;
+
+// sdo is sampled on negative sd clock so set it on positive edge
+always @(posedge buffer_read_latch)
+	buffer_byte <= buffer[buffer_rptr];
+
+always @(posedge buffer_read_strobe or posedge new_cmd_rcvd) begin
+	if(new_cmd_rcvd == 1) buffer_rptr <= 9'd0;
+	else 		             buffer_rptr <= buffer_rptr + 9'd1;
+end
+
+// ---------------- buffer write engine -----------------------
+wire [7:0] buffer_din = reading?io_din:write_data;
+wire buffer_din_strobe = reading?io_din_strobe:write_strobe;
+
+always @(negedge buffer_din_strobe or posedge new_cmd_rcvd) begin
+	if(new_cmd_rcvd == 1) begin
+		buffer_wptr <= 9'd0;
+	end else begin
+		buffer[buffer_wptr] <= buffer_din;	
+		buffer_wptr <= buffer_wptr + 9'd1;
+	end
+end
+
+wire [7:0] WRITE_DATA_RESPONSE = 8'h05;
+
+// ------------------------- CSD/CID BUFFER ----------------------
+assign io_conf = (csd_wptr == 0);  // csd_wptr still 0 -> configuration required
+
+// the 32 bytes as sent from the io controller
+reg [7:0] cid [15:0];
+reg [7:0] csd [15:0];
+reg [7:0] conf;
+
+reg [7:0] cid_byte;
+reg [7:0] csd_byte;
+reg [5:0] csd_wptr = 6'd0;
+
+// conf[0]==1 -> io controller is using an sdhc card
+wire io_has_sdhc = conf[0];
+assign io_sdhc = allow_sdhc && io_has_sdhc;
+
+always @(negedge io_din_strobe) begin
+	// if io controller sends data without asserting io_ack, then it's
+	// updating the config
+	if(!io_ack && (csd_wptr <= 32)) begin
+	
+		if(csd_wptr < 16)                       // first 16 bytes are cid
+			cid[csd_wptr] <= io_din;	
+		if((csd_wptr >= 16) && (csd_wptr < 32)) // then comes csd
+			csd[csd_wptr-16] <= io_din;	
+		if(csd_wptr == 32)                      // finally a config byte
+			conf <= io_din;	
+			
+		csd_wptr	<= csd_wptr + 1;
+	end
+end
+
+always @(posedge buffer_read_latch)
+	cid_byte <= cid[buffer_rptr];
+
+always @(posedge buffer_read_latch)
+	csd_byte <= csd[buffer_rptr];
+	
+// ----------------- spi transmitter --------------------
+reg rd_io_ackD, wr_io_ackD;
+
+always@(negedge sd_sck or posedge sd_cs) begin
+	if(sd_cs == 1) begin
+//	   sd_sdo <= 1'b1;
+//		read_state <= RD_STATE_IDLE;
+	end else begin
+		core_buffer_read_strobe <= 1'b0;
+
+		// using rd_io_ack directly brings the read state machine into an
+		// non-existing state every now and then. For unknown reason
+		rd_io_ackD <= rd_io_ack;
+		
+		// -------- catch read commmand and reset read state machine ------
+		if(bit_cnt == 7) begin
+			if(byte_cnt == 4) begin
+				// CMD17: READ_SINGLE_BLOCK
+				if(cmd == 8'h51)
+					read_state <= RD_STATE_WAIT_IO;      // start waiting for data from io controller
+			end
+		end
+
+      if(byte_cnt < 5+NCR) begin
+		  sd_sdo <= 1'b1;				// reply $ff -> wait
+		end else begin
+
+			if(byte_cnt == 5+NCR) begin
+				sd_sdo <= reply[~bit_cnt];
+
+				if(bit_cnt == 7) begin
+					// CMD9: SEND_CSD
+					// CMD10: SEND_CID
+					if((cmd == 8'h49)||(cmd == 8'h4a))
+						read_state <= RD_STATE_SEND_TOKEN;      // jump directly to data transmission
+				end
+			end
+			else if((reply_len > 0) && (byte_cnt == 5+NCR+1))
+				sd_sdo <= reply0[~bit_cnt];
+			else if((reply_len > 1) && (byte_cnt == 5+NCR+2))
+				sd_sdo <= reply1[~bit_cnt];
+			else if((reply_len > 2) && (byte_cnt == 5+NCR+3))
+				sd_sdo <= reply2[~bit_cnt];
+			else if((reply_len > 3) && (byte_cnt == 5+NCR+4))
+				sd_sdo <= reply3[~bit_cnt];
+			else
+				sd_sdo <= 1'b1;
+				
+			// falling edge of io_ack signals end of incoming data stream
+			if((read_state == RD_STATE_WAIT_IO) && rd_io_ackD)
+				read_state <= RD_STATE_WAIT_START;
+
+			// wait for begin of new byte
+			else if((read_state == RD_STATE_WAIT_START) && (bit_cnt == 7))
+				read_state <= RD_STATE_SEND_TOKEN;
+
+			// send data token
+			else if(read_state == RD_STATE_SEND_TOKEN) begin
+				sd_sdo <= READ_DATA_TOKEN[~bit_cnt];
+				
+				if(bit_cnt == 7)
+					read_state <= RD_STATE_SEND_DATA;   // next: send data
+			end
+
+			// send data
+			else if(read_state == RD_STATE_SEND_DATA) begin
+				if(cmd == 8'h51) 							// CMD17: READ_SINGLE_BLOCK
+					sd_sdo <= buffer_byte[~bit_cnt];
+				else if(cmd == 8'h49) 					// CMD9: SEND_CSD
+					sd_sdo <= csd_byte[~bit_cnt];
+				else if(cmd == 8'h4a) 					// CMD10: SEND_CID
+					sd_sdo <= cid_byte[~bit_cnt];
+
+				if(bit_cnt == 7) begin
+					core_buffer_read_strobe <= 1'b1;
+				
+					// send 512 sector data bytes?
+					if((cmd == 8'h51) && (buffer_rptr == 511))
+						read_state <= RD_STATE_SEND_CRC0;   // next: send crc
+						
+					// send 16 cid/csd data bytes?
+					if(((cmd == 8'h49)||(cmd == 8'h4a)) && (buffer_rptr == 15))
+						read_state <= RD_STATE_IDLE;   // return to idle state
+				end
+			end
+			
+			// send crc[0]
+			else if(read_state == RD_STATE_SEND_CRC0) begin
+				sd_sdo <= 1'b1;
+				if(bit_cnt == 7)
+					read_state <= RD_STATE_SEND_CRC1;  // send second crc byte
+			end
+			
+			// send crc[1]
+			else if(read_state == RD_STATE_SEND_CRC1) begin
+				sd_sdo <= 1'b1;
+				if(bit_cnt == 7)
+					read_state <= RD_STATE_IDLE;  // return to idle state
+			end
+						
+			// ------------------ write support ----------------------
+			// send write data response
+			if(write_state == WR_STATE_SEND_DRESP) 
+				sd_sdo <= WRITE_DATA_RESPONSE[~bit_cnt];
+
+			// busy after write until the io controller sends ack
+			if(write_state == WR_STATE_BUSY) 
+				sd_sdo <= 1'b0;
+		end
+   end
+end
+
+// spi receiver  
+always @(posedge sd_sck or posedge sd_cs) begin
+	// cs is active low
+	if(sd_cs == 1) begin
+		bit_cnt <= 3'd0;
+//		byte_cnt <= 4'd15;
+//		write_state <= WR_STATE_IDLE;
+//		write_strobe <= 1'b0;
+	end else begin 
+		new_cmd_rcvd <= 1'b0;
+		write_strobe <= 1'b0;
+		sbuf[6:0] <= { sbuf[5:0], sd_sdi };
+		bit_cnt <= bit_cnt + 3'd1;
+		
+		// using wr_io_ack directly brings the write state machine into an
+		// non-existing state every now and then. For unknown reason
+		wr_io_ackD <= wr_io_ack;
+
+		// finished reading command byte
+		if(bit_cnt == 7) begin
+			// byte counter runs against 15 byte boundary
+			if(byte_cnt != 15)
+				byte_cnt <= byte_cnt + 8'd1;			
+
+			// byte_cnt > 6 -> complete command received
+				// first byte of valid command is 01xxxxxx
+ 			if((byte_cnt > 5) && (write_state == WR_STATE_IDLE) && sbuf[6:5] == 2'b01)
+				byte_cnt <= 4'd0;			
+
+			// don't accept new commands once a write command has been accepted
+			if((write_state == WR_STATE_IDLE) && (byte_cnt > 5)&&(sbuf[6:5] == 2'b01)) begin
+				cmd <= { sbuf, sd_sdi};
+				new_cmd_rcvd <= 1'b1;
+
+			   // set cmd55 flag if previous command was 55
+			   cmd55 <= (cmd == 8'h77);
+			end
+
+			// parse additional command bytes
+			if(byte_cnt == 0) lba[31:24] <= { sbuf, sd_sdi};
+			if(byte_cnt == 1) lba[23:16] <= { sbuf, sd_sdi};
+			if(byte_cnt == 2) lba[15:8]  <= { sbuf, sd_sdi};
+			if(byte_cnt == 3) lba[7:0]   <= { sbuf, sd_sdi};			
+
+			// last byte received, evaluate
+			if(byte_cnt == 4) begin		
+				// crc is currently unused
+				crc  <= { sbuf, sd_sdi};
+			
+				// default:
+				reply <= 8'h04;     // illegal command
+				reply_len <= 4'd0;  // no extra reply bytes
+				
+				// CMD0: GO_IDLE_STATE
+				if(cmd == 8'h40)
+					reply <= 8'h01;    // ok, busy
+
+				// CMD1: SEND_OP_COND
+				else if(cmd == 8'h41)
+					reply <= 8'h00;    // ok, not busy
+					
+				// CMD8: SEND_IF_COND (V2 only)
+				else if(cmd == 8'h48) begin
+					reply <= 8'h01;    // ok, busy
+					reply0 <= 8'h00;
+					reply1 <= 8'h00;
+					reply2 <= 8'h01;
+					reply3 <= 8'hAA;
+					reply_len <= 4'd4;
+				end
+				
+				// CMD9: SEND_CSD
+				else if(cmd == 8'h49)
+					reply <= 8'h00;    // ok
+				
+				// CMD10: SEND_CID
+				else if(cmd == 8'h4a)
+					reply <= 8'h00;    // ok
+				
+				// CMD16: SET_BLOCKLEN
+				else if(cmd == 8'h50) begin
+				   // we only support a block size of 512
+				   if(io_lba == 32'd512)
+						reply <= 8'h00;    // ok
+				   else
+						reply <= 8'h40;    // parmeter error
+				end
+
+				// CMD17: READ_SINGLE_BLOCK
+				else if(cmd == 8'h51)
+					reply <= 8'h00;    // ok
+
+				// CMD24: WRITE_BLOCK
+				else if(cmd == 8'h58) begin
+					reply <= 8'h00;    // ok
+					write_state <= WR_STATE_EXP_DTOKEN;  // expect data token
+				end
+
+			   // ACMD41: APP_SEND_OP_COND
+			   else if(cmd55 && (cmd == 8'h69))
+					reply <= 8'h00;    // ok, not busy
+	
+				// CMD55: APP_COND
+				else if(cmd == 8'h77)
+					reply <= 8'h01;    // ok, busy
+
+				// CMD58: READ_OCR
+				else if(cmd == 8'h7a) begin
+					reply <= 8'h00;    // ok
+					
+					reply0 <= OCR[31:24];   // bit 30 = 1 -> high capacity card 
+					reply1 <= OCR[23:16];
+					reply2 <= OCR[15:8];
+					reply3 <= OCR[7:0];
+					reply_len <= 4'd4;
+				end
+			end
+			
+			// ---------- handle write -----------
+			
+			// waiting for data token
+			if(write_state == WR_STATE_EXP_DTOKEN) begin
+				if({ sbuf, sd_sdi} == 8'hfe )
+					write_state <= WR_STATE_RECV_DATA;
+			end
+
+			// transfer 512 bytes
+			if(write_state == WR_STATE_RECV_DATA) begin
+				// push one byte into local buffer
+				write_strobe <= 1'b1;
+				write_data <= { sbuf, sd_sdi};
+				
+				if(buffer_wptr == 511)
+					write_state <= WR_STATE_RECV_CRC0;
+			end
+	
+			// transfer 1st crc byte
+			if(write_state == WR_STATE_RECV_CRC0)
+				write_state <= WR_STATE_RECV_CRC1;
+
+			// transfer 2nd crc byte
+			if(write_state == WR_STATE_RECV_CRC1)
+				write_state <= WR_STATE_SEND_DRESP;
+	
+			// send data response
+			if(write_state == WR_STATE_SEND_DRESP)
+				write_state <= WR_STATE_BUSY;
+		end
+				
+		// wait for io controller to accept data
+		// this happens outside the bit_cnt == 7 test as the 
+		// transition may happen at any time
+		if(write_state == WR_STATE_BUSY && wr_io_ackD)
+			write_state <= WR_STATE_IDLE;
+	end
+end
+
+endmodule
Index: mist_5200/atari800core.qsf
===================================================================
--- mist_5200/atari800core.qsf	(revision 231)
+++ mist_5200/atari800core.qsf	(revision 232)
@@ -308,11 +308,11 @@
 
 set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top
 
-set_global_assignment -name VHDL_FILE data_io.vhdl
 set_global_assignment -name VHDL_FILE zpu_rom.vhdl
 set_global_assignment -name SDC_FILE atari800core.sdc
 set_global_assignment -name QIP_FILE mist_sector_buffer.qip
 set_global_assignment -name VHDL_FILE atari800core_mist.vhd
+set_global_assignment -name VERILOG_FILE sd_card.v
 set_global_assignment -name VERILOG_FILE user_io.v
 set_global_assignment -name QIP_FILE pll_pal_pre.qip
 set_global_assignment -name QIP_FILE pll_pal_post.qip
